﻿/*******************************************************
Sakaiden Class
********************************************************
Name:SkdRandomImgFeed
Created By:CaptainHansode

イメージをランダムで読み込む
*******************************************************/
///////////////////////////////////////////////////
//まずはこのクラスのパス
//
package sakaiden
{
///////////////////////////////////////////////////
//必要なクラスを取得しておく
//なんだかいつも適当
import flash.display.Loader;
import flash.display.LoaderInfo;
import flash.system.LoaderContext;

import flash.display.*;
import flash.events.*;
import flash.net.URLRequest;


	///////////////////////////////////////////////////
	//次にクラス
	//これはムービークリップのサブクラス
	public class SkdRandomImgFeed extends MovieClip
	{
		///////////////////////////////////////////////////
		//コンストラクタ
		//
		//引数は、ファイルまでのURL（パス）、イメージ名、イメージ種類、イメージ数
		//イメージは0番以上から
		//例、image0.jpgなどなど
		//
		//
		public function SkdRandomImgFeed(in_passStr:String = "http:///", in_nameStr:String = "image", in_imgType:String = "jpg", in_imageNum:Number = 1)
		{
			//引数から代入
			passStr = in_passStr;
			nameStr = in_nameStr;
			imgType = in_imgType;
			imageNum = in_imageNum;			
		};//constructor end
		
		///////////////////////////////////////////////////
		//プロパティを設定
		public var passStr:String;
		public var nameStr:String;
		public var imgType:String;
		public var imageNum:Number;
		private var urlStr:String;
		
		///////////////////////////////////////////////////
		//メソッド
		
		///////////////////////////////////////////////////
		//実際に読み込みを行う
		//
		public function loadImage():void
		{
			//イメージまでのパスをつくる、まずは変数
			var num = Math.floor( ( Math.random() * imageNum - 0 +1 ) + 0 );
			
			//パスを作る部分
			urlStr = passStr + nameStr + num + "." + imgType;
			
			//ちょっと確認
			trace("読み込む画像は  "+urlStr+"  なのさ");
			
			//まずはローダーを作って格納
			var loader:Loader = new Loader();
			
            // Loaderコンテキストを準備しておく
			//よくわからんがあったほうがいいみたい、クロスドメイン対策だそうだ
            var context:LoaderContext = new LoaderContext(true);
     			
			//いざ読み込み
			loader.load(new URLRequest(urlStr),context);

				///////////////////////////////////////////////
				//読み込み中の処理
				//contentLoaderInfoにイベントを追加する
				loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, progressListener);
				function progressListener (e:ProgressEvent):void{

					//progBarムービークリップのスケールアニメ
					progBar.scaleX = 0;

					//お知らせ
					trace("読み込んだのは " + e.bytesLoaded + " / " + e.bytesTotal + " bytes");
					
					//スケール値を計算
					var progCount = e.bytesLoaded / e.bytesTotal;
					
					//progBarムービークリップのスケールアニメ
					progBar.scaleX = progCount;
					
					//絶対パスの場合はこっち
					//root.testImg.progBar.scaleX = progCount;
					
				}//fn end


				///////////////////////////////////////////////
				//ロード処理が完了したら
				//contentLoaderInfoにイベントを追加する
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, startListener);
				function startListener (e:Event):void{

					//余計なインスタンスを削除しておく
					//removeChild(progBar);
					//progBar = null;

					//読み込んだものをムービークリップ内のimgTagに入れる
					//imgTagはあらかじめ準備しておく事
					//imgTag自体にアルファのアニメーションが入っている
					//addChild(loader);
					imgTag.addChild(loader);
					
					//絶対パスの場合はこっち
					//root.testImg.imgTag.addChild(loader);
				
					//以下の名前のフレームに行き再生する
					gotoAndPlay("Complete")
					
					//お知らせ
					trace("読み込みおわったよ");
					
				}//fn end
			
			
			return;
		};//fn end
		
	};//public end
};//class end